#!/usr/bin/perl

%SensorBit = (
   '00' => { 'Chip' => '1', 'Bit' => 'GPIOA0', 'Desc' => 'Block detector B01' },
   '01' => { 'Chip' => '1', 'Bit' => 'GPIOA1', 'Desc' => 'Block detector B02' },
   '02' => { 'Chip' => '1', 'Bit' => 'GPIOA2', 'Desc' => 'Block detector B03' },
   '03' => { 'Chip' => '1', 'Bit' => 'GPIOA3', 'Desc' => 'Block detector B04' },
   '04' => { 'Chip' => '1', 'Bit' => 'GPIOA4', 'Desc' => 'Block detector B05' },
   '05' => { 'Chip' => '1', 'Bit' => 'GPIOA5', 'Desc' => 'Block detector B06' },
   '06' => { 'Chip' => '1', 'Bit' => 'GPIOA6', 'Desc' => 'Block detector B07' },
   '07' => { 'Chip' => '1', 'Bit' => 'GPIOA7', 'Desc' => 'Block detector B08' },
   '08' => { 'Chip' => '1', 'Bit' => 'GPIOB0', 'Desc' => 'Block detector B09' },
   '09' => { 'Chip' => '1', 'Bit' => 'GPIOB1', 'Desc' => 'Block detector B10' },
   '10' => { 'Chip' => '1', 'Bit' => 'GPIOB2', 'Desc' => 'GradeCrossing 1 AprEast' },
   '11' => { 'Chip' => '1', 'Bit' => 'GPIOB3', 'Desc' => 'GradeCrossing 1 Road' },
   '12' => { 'Chip' => '1', 'Bit' => 'GPIOB4', 'Desc' => 'GradeCrossing 1 AprWest' },
   '13' => { 'Chip' => '1', 'Bit' => 'GPIOB5', 'Desc' => 'GradeCrossing 2 AprEast' },
   '14' => { 'Chip' => '1', 'Bit' => 'GPIOB6', 'Desc' => 'GradeCrossing 2 Road' },
   '15' => { 'Chip' => '1', 'Bit' => 'GPIOB7', 'Desc' => 'GradeCrossing 2 AprWest' },
   '16' => { 'Chip' => '2', 'Bit' => 'GPIOA0', 'Desc' => 'Unused' },
   '17' => { 'Chip' => '2', 'Bit' => 'GPIOA1', 'Desc' => 'Unused' },
   '18' => { 'Chip' => '2', 'Bit' => 'GPIOA2', 'Desc' => 'Unused' },
   '19' => { 'Chip' => '2', 'Bit' => 'GPIOA3', 'Desc' => 'Unused' },
   '20' => { 'Chip' => '2', 'Bit' => 'GPIOA4', 'Desc' => 'Unused' },
   '21' => { 'Chip' => '2', 'Bit' => 'GPIOA5', 'Desc' => 'Unused' },
   '22' => { 'Chip' => '2', 'Bit' => 'GPIOA6', 'Desc' => 'Unused' },
   '23' => { 'Chip' => '2', 'Bit' => 'GPIOA7', 'Desc' => 'Unused' },
   '24' => { 'Chip' => '2', 'Bit' => 'GPIOB0', 'Desc' => 'Unused' },
   '25' => { 'Chip' => '2', 'Bit' => 'GPIOB1', 'Desc' => 'Unused' },
   '26' => { 'Chip' => '2', 'Bit' => 'GPIOB2', 'Desc' => 'Unused' },
   '27' => { 'Chip' => '2', 'Bit' => 'GPIOB3', 'Desc' => 'Unused' },
   '28' => { 'Chip' => '2', 'Bit' => 'GPIOB4', 'Desc' => 'Unused' },
   '29' => { 'Chip' => '2', 'Bit' => 'GPIOB5', 'Desc' => 'Unused' },
   '30' => { 'Chip' => '2', 'Bit' => 'GPIOB6', 'Desc' => 'Unused' },
   '31' => { 'Chip' => '2', 'Bit' => 'GPIOB7', 'Desc' => 'Unused' });

foreach $key (sort keys %SensorBit) {
   print "key: $key   modulo: " . $key % 16 . "\n";
}